﻿Type=Class
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
'Events declaration
#Event: Result( col As Int, res() As Int)
Sub Class_Globals
	Private closebtn As Button
	Private colorbtn As  Button
	Private cnvs As Canvas
	Private cx, cy, r1, r2 As Float
	Private selectedcolor As Int 
	Private originalcolor As Int
	Private mymodule As Object
	Private backpnl, basepnl, palette, pltcursor As Panel
	Private myname As String
End Sub

'Initializes the object. 
Public Sub Initialize(Parent As Activity, Module As Object, Eventname As String, Background As Int)
mymodule = Module
myname = Eventname

Dim CF As Double =  Sqrt((100%y * 100%y + 100%x * 100%x)/(Power(430 * Density,2) + Power(800 * Density,2))) 

backpnl.Initialize("backpnl")
Parent.AddView(backpnl,0,0,100%x,100%y)
backpnl.Color = Colors.DarkGray '.Black

basepnl.Initialize("")
basepnl.color = Background

palette.Initialize("palette")

pltcursor.Initialize("")
pltcursor.SetBackgroundImage(LoadBitmap(File.DirAssets,"cursor.png"))

	selectedcolor = Colors.RGB(50,50,255)
	originalcolor = selectedcolor
	
Dim dr As ColorDrawable ' Colors.LightGray
dr.Initialize2(originalcolor,0,0,Colors.black)
closebtn.Initialize("closebtn")
closebtn.Background = dr
closebtn.Typeface = Typeface.DEFAULT_BOLD
closebtn.Text = "Original"
closebtn.TextColor = Colors.black
closebtn.TextSize = 20 * CF
						'1.0%x	'0.5%x
dr.Initialize2(selectedcolor,0,0,Colors.black)
colorbtn.Initialize("colorbtn")
colorbtn.Background = dr
colorbtn.text = "New"
colorbtn.Typeface = Typeface.DEFAULT_BOLD
colorbtn.Gravity = Bit.Or(Gravity.CENTER_VERTICAL, Gravity.CENTER_HORIZONTAL)
colorbtn.textsize = 20 * CF

	buttontextcolor(closebtn,originalcolor)

Dim bmp As Bitmap
bmp.Initialize(File.DirAssets,"RPC.png")
Dim rect0,rect1 As Rect
rect0.Initialize(0,0,bmp.Width,bmp.Height)

If Parent.Width < Parent.Height Then
	backpnl.AddView(basepnl,10%x,15%y,80%x,80%x)
	basepnl.AddView(palette,0%x,0%x,80%x,80%x)
	cx = 40%x
	cy = 40%x
	r1 = 30%x
	r2 = 40%x
	basepnl.AddView(pltcursor,cx-15%x,cy+7%x,2%x,2%x)
	rect1.Initialize(10%x,10%x,70%x,70%x)
	'basepnl.AddView(colorbtn,5.5%x,83%x,35%x,11%x)
	'basepnl.AddView(closebtn,40.5%x,83%x,35%x,11%x)
		backpnl.AddView(colorbtn,15.5%x,8%x,35%x,11%x)
		backpnl.AddView(closebtn,50.5%x,8%x,35%x,11%x)
	closebtn.Left = colorbtn.Left+colorbtn.width
Else
	backpnl.AddView(basepnl,50%x-40%y,15%y,80%y,80%y)
	basepnl.AddView(palette,0%x,0%x,80%y,80%y)
	cx = 40%y
	cy = 40%y
	r1 = 30%y
	r2 = 40%y
	basepnl.AddView(pltcursor,cx-15%y,cy+7%y,2%y,2%y)
	rect1.Initialize(10%y,10%y,70%y,70%y)
	'basepnl.AddView(colorbtn,5.5%y,83%y,35%y,11%y)
	'basepnl.AddView(closebtn,40.5%y,83%y,35%y,11%y)
		backpnl.AddView(colorbtn,50%x - 40%y + 5.5%y,2%y,35%y,11%y)
		backpnl.AddView(closebtn,50%x - 40%y + 40.5%y,2%y,35%y,11%y)
		closebtn.Left = colorbtn.Left+colorbtn.width
End If
cnvs.Initialize(palette)
cnvs.DrawBitmap(bmp,rect0,rect1)
backpnl.Visible = False

End Sub

Public Sub AsView As View
Return backpnl
End Sub

Private Sub drawlum  
Dim res() As Int 
res = ParseColor(selectedcolor)
Dim col As Int
Dim delR1,delG1,delB1,delR2,delG2,delB2 As Double
delR1 = (255-res(1))/360
delG1 = (255-res(2))/360
delB1 = (255-res(3))/360
delR2 = res(1)/360
delG2 = res(2)/360
delB2 = res(3)/360
	For i = 0 To 360*2
		Dim f As Double = (i/2)
		Dim fdiv2 As Double = f/2.0
		Dim sinpfd2 As Double = SinD(fdiv2)
		Dim sinmfd2 As Double = SinD(-fdiv2)
		Dim cospfd2 As Double = CosD(fdiv2)
		Dim cosmfd2 As Double = CosD(-fdiv2)
		'right half
		col = Colors.RGB(255- f*delR1, 255- f*delG1, 255- f*delB1)
		cnvs.DrawLine(cx+(r1-1)*sinpfd2,cy-(r1-1)*cospfd2,cx+r2*sinpfd2,cy-r2*cospfd2,col,4)
		'left half
		col = Colors.RGB(f*delR2, f*delG2, f*delB2)
		cnvs.DrawLine(cx+(r1-1)*sinmfd2,cy-(r1-1)*cosmfd2,cx+r2*sinmfd2,cy-r2*cosmfd2,col,4)
	Next
palette.Invalidate
End Sub

Private Sub ParseColor(clr As Int) As Int()
Dim res(4) As Int
res(0) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff000000), 24) ' alfa
res(1) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff0000), 16)   ' R
res(2) = Bit.UnsignedShiftRight(Bit.And(clr, 0xff00), 8)      ' G
res(3) = Bit.And(clr, 0xff)  ' B
	Return res
End Sub

Public Sub contrast(res() As Int) As Int
	If (res(1)+res(2)+res(3)) > 400 Then '240 Then
		Return Colors.Black
	Else
		Return Colors.white
	End If
End Sub

private Sub buttontextcolor(thebtn As Button, backgroundcolor As  Int)
	Dim res(4) As Int
	res = ParseColor(backgroundcolor)
	Dim dr As ColorDrawable
	thebtn.TextColor = contrast(res)
	dr.Initialize2(backgroundcolor,0,0,thebtn.TextColor)
	thebtn.Background = dr
End Sub

'Shows the palette and enables coosing the color. 
'Ruturns the color as Int and As A,R,G,B In Sub Eventname_Result In the calling module.
Public Sub GetColor 
	buttontextcolor(closebtn,originalcolor)
	buttontextcolor(colorbtn,selectedcolor)
drawlum
backpnl.Visible = True
End Sub

Private Sub colorbtn_click
	originalcolor = selectedcolor
backpnl.Visible = False
CallSub3(mymodule, myname & "_Result", selectedcolor, ParseColor(selectedcolor))
End Sub

Private Sub closebtn_click
selectedcolor = originalcolor
backpnl.Visible = False
End Sub

Private Sub palette_Touch (Action As Int, X As Float, Y As Float)
	Dim rTouch = Sqrt((cx-X)*(cx-X)+(cy-Y)*(cy-Y))
	If rTouch+1<r2 Then
	Dim clr As Int = cnvs.Bitmap.GetPixel(X,Y)

	selectedcolor = clr
	If rTouch+1 < r1 Then  drawlum

    buttontextcolor(colorbtn,selectedcolor)
	Dim dr As ColorDrawable
	dr.Initialize2(selectedcolor,0,0,colorbtn.TextColor)
	basepnl.Background = dr
		
pltcursor.SetLayout(X-pltcursor.Width/2,Y-pltcursor.Height/2,pltcursor.Width,pltcursor.height)
End If
End Sub

Private Sub  backpnl_Touch (Action As Int, X As Float, Y As Float)
End Sub
